#!/usr/bin/env python
# -*- coding: utf-8 -*-
# License:: GPL
# Author:: Alberto Milone (aka tseliot) (mailto:albertomilone@alice.it)
# Website:: http://albertomilone.com

import sys
import commands
import string
import os
from os.path import isfile
from subprocess import Popen, PIPE
import shutil
import fileinput, re
import main
import objects
import classes
atimanlatest = '8.39.4'
atimanlegacy = '8.28.8'
nvmanlatest = '100.14.11'
nvmannewlegacy = '9639'
nvmanlegacy = '7185'
#self.nvdistinction = 'linux-restricted-modules-' + str(os.uname()[2])
#newmethodos = ['feisty', 'gutsy']
newmethodos = ['feisty', 'gutsy']


class Replacement:
    def replaceline(self, filename, pattern, replacement):#replaces 1 line with another
        lines = []
        pat1 = re.compile(pattern)
        text = open(filename, 'r')
        optext = text.readlines()
        for line in optext:
            m1 = pat1.match(line)
            if m1:
                line = replacement
                lines.append(line)
            else:
                lines.append(line)
        text.close()
        sep = ''
        modtext = open(filename, 'w')
        a = sep.join(lines)
        modtext.write(a)
        modtext.close()
        
        
    def replaceelem(self, filename, pattern, replacement):#replaces 1 element in a string
        lines = []
        text = open(filename, 'r')
        optext = text.readlines()
        for line in optext:
            line = line.replace(pattern, replacement)
            #print line
            lines.append(line)
        text.close()
        sep = ''
        modtext = open(filename, 'w')
        a = sep.join(lines)
        modtext.write(a)
        modtext.close()

class Shutilities:#Debpackages
    def cmdoutput(self, command, verbose=None):
        '''
        USAGE: 
        * the command must be a string
        * you can pass 'noverbose' in order to make sure that stderr > /dev/null
        '''
        if verbose == 'noverbose':
            NULL = open('/dev/null', 'w')
            comnd = Popen(command, shell=True, stdout=PIPE, stderr=NULL)
            sts = os.waitpid(comnd.pid, 0)
            NULL.close()
        else:
            comnd = Popen(command, shell=True)# stdout=PIPE)
            sts = os.waitpid(comnd.pid, 0)
        #commandnew = comnd.communicate()[0]

    def checkpkg(self, pkglist):
        '''
        USAGE:
            * pkglist is the list of packages  you want to check
            * use lists for one or more packages
            * use a string if it is only one package
            * lists will work well in both cases
        '''
        '''
        Checks whether all the packages in the list are installed
        and returns a list of the packages which are not installed
        '''
        lines = []
        notinstalled = []
        p1 = Popen(['dpkg', '--list'], stdout=PIPE)
        p = p1.communicate()[0]
        c = p.split('\n')
        for line in c:
            if line.find('ii') != -1:#the relevant lines
                lines.append(line.split('  ')[1])
        if str(type(pkglist)) == '<type \'str\'>':#if it is a string
            try:
                if lines.index(pkglist):
                    pass
            except ValueError:
                notinstalled.append(pkglist)
        else:#if it is a list
            for pkg in pkglist:
                try:
                    if lines.index(pkg):
                        pass
                except ValueError:
                    notinstalled.append(pkg)
        
        return notinstalled

    def pkginstall(self, pkglist):
        '''
        If some of the packages in the list have not yet been installed
        pkginstall will:
        * attempt to install the missing packages
        '''
        sep = ' '
        a = self.checkpkg(pkglist)
        if len(a) != 0:
            print 'ENVY: The following packages are not installed:'
            for x in a: print x
            print '\nENVY: attempting to install the packages'
            if str(type(pkglist)) == '<type \'str\'>':#if it is a string
                packages = pkglist
            else:#if it is a list
                packages = sep.join(a)
            self.cmdoutput('sudo apt-get --assume-yes install ' + packages)
        else:
            print '\nOK: All the packages are installed'
            
    def checkntry(self, pkglist):
        '''
        If some of the packages in the list have not yet been installed
        checkntry will:
        * attempt to install the missing packages
        * stop the application if installing these packages is not possible
        '''
        self.pkginstall(pkglist)
        a = self.checkpkg(pkglist)#check again
        if len(a) != 0:
            print '\nENVY ERROR: The following packages cannot be installed:'
            for y in a: print y
            sys.exit()
    
    def pkgremove(self, pkglist, deep=None):
        newpkglist = []#packages which are installed and have to be removed
        sep = ' '
        a = self.checkpkg(pkglist)
        if str(type(pkglist)) == '<type \'str\'>':#if it is a string
            if pkglist not in a:#if it is installed
                newpkglist.append(pkg)
        else:#if it is a list
            for pkg in pkglist:
                if pkg not in a:#if it is installed
                    newpkglist.append(pkg)
        if deep != None:
            command = 'sudo apt-get --assume-yes remove --purge '
            #print command
        else:
            command = 'sudo apt-get  --assume-yes remove '
            #print command
        if len(newpkglist) != 0:
            print 'ENVY: The following packages will be removed:'
            for y in newpkglist: print y
            print '\nENVY: attempting to remove the packages'
            packages = sep.join(newpkglist)
            #print packages
            self.cmdoutput(command + packages, 'noverbose')

#class Fileops:
    def remove(self, files, verb=None):
        #self.command e.g. 'sudo rm '
        fileslist = []
        if str(type(files)) == '<type \'str\'>':#if it is a string
            fileslist.append(files)
        else:#if it is a list, tuple, etc.
            for elem in files:
                fileslist.append(elem)
        #if verb == 'noverbose':
        #    err = 'noverbose'
        #else:
        #    err = 'verbose'
        for file in fileslist:
            fullcommand = self.command + file
            #print fullcommand
            self.cmdoutput(fullcommand, verb)#stderr > /dev/null
    
    def removedirs(self, files, verb=None):#pass noverbose
        '''
        Removes dirs recursively
        USAGE:
            * pass the path to the dir or a list of paths
            * pass 'noverbose' in order to make sure that stderr > /dev/null
        '''
        self.command = 'sudo rm -R '
        self.remove(files, verb)

    def removefiles(self, files, verb=None):
        '''
        Removes files
        USAGE:
            * pass the path to the file or a list of files
            * pass 'noverbose' in order to make sure that stderr > /dev/null
        '''
        self.command = 'sudo rm '
        self.remove(files, verb)


class Vars:
    def init(self):
        self.atimanlatest = atimanlatest
        self.atimanlegacy = atimanlegacy
        self.nvmanlatest = nvmanlatest
        self.nvmannewlegacy = nvmannewlegacy
        self.nvmanlegacy = nvmanlegacy

class Compatibcheck:
    #def init(self):
    #    self.brandname = 'none'# either "Nvidia" or "ATI"
        
    def check(self):#oldname "checkcompatib()"
        a1 = Popen(['lspci'], stdout=PIPE)
        a2 = Popen(['grep', 'VGA'], stdin=a1.stdout, stdout=PIPE)
        a = a2.communicate()[0]
        b = a.lower().split(' ')
        c = self.brandname.lower()
        if c not in b:#if there's no trace of either ati or nvidia in the output
            print 'ENVY ERROR: ' + self.brandname + ' card not found'
            event = 'error'
        else:
            event = 'passed'
        return event

class Rdrvmanager:
    def init(self):
        self.content = '\
# Make nvidia/nvidia_legacy and fglrx use /sbin/lrm-video to load\n\
install fglrx /sbin/lrm-video fglrx $CMDLINE_OPTS\n\
install nvidia /sbin/lrm-video nvidia $CMDLINE_OPTS\n\
install nvidia_legacy /sbin/lrm-video nvidia_legacy $CMDLINE_OPTS\n\
install nvidia_new /sbin/lrm-video nvidia_new $CMDLINE_OPTS\n'
    
    def actionlist(self):
        newcontent = []
        sep = ''
        if self.action != 'none':
            if self.action == 'blacklist':
                elem = '#'
            elif self.action == 'deblacklist':
                elem = ''
            rawcontent = self.content.split('\n')
            for line in rawcontent:
                newcontent.append(elem + line +'\n')
            restmanager = open('/etc/modprobe.d/lrm-video', 'w')
            restmanager.write(sep.join(newcontent))

class Specsdetect:

    def init(self):
    #    self.cards = {}
    #    self.middlecards = {}
    #    self.legacycards = {}
        self.details = {}#all the details about the card, driver, arch are stored here
    
    def codename(self):
        """
        Get system codename, can be warty/hoary/breezy/dapper/edgy/etch
        """
        p1 = Popen(['lsb_release', '-c'], stdout=PIPE)
        p = p1.communicate()[0]
        try:
            codename = p.strip()
            tokens = codename.split("\t")
        except AttributeError:
            print 'ERROR: please install lsb-release'
            sys.exit()
        self.details['osname'] = tokens[-1].lower()
        self.legacyos = ['dapper', 'etch', 'sid']
    
    def architecture(self):
        """
        Detect whether the architecture is x86/ppc/amd64 
        """
        arch = os.uname()[-1]
        if arch in ('ppc', 'ppc64'):
            arch = 'powerpc'
        elif arch =='x86_64':
            arch = 'x86_64'
        elif arch in ('i386','i686','i586','k7'):
            arch = 'x86'
        self.details['arch'] = arch#formerly known as "arca"
    
    def systemcheck(self):#It is based upon details[0] and details[1]
        if self.details['osname'] == 'dapper':
            if self.details['arch'] == 'x86':
                print 'Ubuntu Dapper 32bit'
            elif self.details['arch'] == 'x86_64':
                print 'Ubuntu Dapper 64bit' 
            else:
                print 'ENVY ERROR: Your architecture is not supported by Envy'
                sys.exit()
        elif self.details['osname'] == 'edgy':#SUPPORT FOR EDGY
            if self.details['arch'] == 'x86':
                print 'Ubuntu Edgy 32bit'
            elif self.details['arch'] == 'x86_64':
                print 'Ubuntu Edgy 64bit' 
            else:
                print 'ENVY ERROR: Your architecture is not supported by Envy'
                sys.exit()
        elif self.details['osname'] == 'feisty':#SUPPORT FOR FEISTY
            if self.details['arch'] == 'x86':
                print 'Ubuntu Feisty 32bit'
            elif self.details['arch'] == 'x86_64':
                print 'Ubuntu Feisty 64bit' 
            else:
                print 'ENVY ERROR: Your architecture is not supported by Envy'
                sys.exit()
        elif self.details['osname'] == 'cassandra':#SUPPORT FOR LINUX MINT CASSANDRA
            self.details['osname'] = 'feisty'#this will make it act like feisty
            if self.details['arch'] == 'x86':
                print 'Linux Mint Cassandra 32bit'
            elif self.details['arch'] == 'x86_64':
                print 'Linux Mint Cassandra 64bit' 
            else:
                print 'ENVY ERROR: Your architecture is not supported by Envy'
                sys.exit()
        elif self.details['osname'] == 'etch':#SUPPORT FOR ETCH
            if self.details['arch'] == 'x86':
                print 'Debian Etch 32bit'
            elif self.details['arch'] == 'x86_64':
                print 'Debian Etch 64bit' 
            else:
                print 'ENVY ERROR: Your architecture is not supported by Envy'
                sys.exit()

        else:
            print "ENVY ERROR: Your Operative System does not seem to be supported by Envy"
            sys.exit()
    
    def drivertype(self):
        geforcego = ['0112', '0172', '0174', '0175', '0176', '0177', '0179', '0286', '017d' ]#need to use dfp
        availabledrv = []#the list of drivers which your system supports
        systemcards = []
        p1 = Popen(['lspci', '-n'], stdout=PIPE)
        p = p1.communicate()[0].split('\n')
        indentifier1 = re.compile('.*0300:.*:(.+) \(.+\)')
        indentifier2 = re.compile('.*0300:.*:(.+)')
        for line in p:#self.completetxt:#self.logged:
            m1 = indentifier1.match(line)
            m2 = indentifier2.match(line)
            if m1:
                id = m1.group(1).strip().lower()
                systemcards.append(id)
            elif m2:
                id = m2.group(1).strip().lower()
                systemcards.append(id)
        for card in systemcards:
            if card in geforcego:
                self.details['geforcego'] = 'true'#will be used by nvxorgset
            #detect the card and choose the driver accordingly
            if self.cards.setdefault(card, 'N/A') != 'N/A':
                print 'Your graphic card has been detected as a ' + self.cards[card]
                print 'Your graphic card is supported by the latest driver'
                drvtype = 'latest'
            elif self.middlecards.setdefault(card, 'N/A') != 'N/A':
                print 'Your graphic card has been detected as a ' + self.middlecards[card]
                print 'Your graphic card is supported by the new legacy driver'
                drvtype = 'middle'
            elif self.legacycards.setdefault(card, 'N/A') != 'N/A':
                print 'Your graphic card has been detected as a ' + self.legacycards[card]
                print 'Your graphic card is supported by the legacy Driver'
                drvtype = 'oldest'
            else:
                drvtype = 'unsupported'
            availabledrv.append(drvtype)
        if 'latest' in availabledrv:#select the driver following this priority: latest, middle, oldest
            self.details['drvtype'] = 'latest'
        else:
            if 'middle' in availabledrv:
                self.details['drvtype'] = 'middle'
            else:
                if 'oldest' in availabledrv:
                    self.details['drvtype'] = 'oldest'
                else:#if the CARD is NOT SUPPORTED
                    print 'ENVY ERROR: Envy does not recognise your card as compatible with any version of the driver.\
this might happen because either your card is not supported by the driver or Envy\'s hardware\
detection failed. You can try the manual installation at your risk.'
                    sys.exit()
    
    
    def geforcegocheck(self):
        geforcego = ['0112', '0172', '0174', '0175', '0176', '0177', '0179', '0286', '017d' ]#need to use dfp
        availabledrv = []#the list of drivers which your system supports
        systemcards = []
        p1 = Popen(['lspci', '-n'], stdout=PIPE)
        p = p1.communicate()[0].split('\n')
        indentifier1 = re.compile('.*0300:.*:(.+) \(.+\)')
        indentifier2 = re.compile('.*0300:.*:(.+)')
        for line in p:#self.completetxt:#self.logged:
            m1 = indentifier1.match(line)
            m2 = indentifier2.match(line)
            if m1:
                id = m1.group(1).strip().lower()
                systemcards.append(id)
            elif m2:
                id = m2.group(1).strip().lower()
                systemcards.append(id)
        for card in systemcards:
            if card in geforcego:
                self.details['geforcego'] = 'true'#will be used by nvxorgset
    
    def driverpushback(self):
        availabledrv = []#the list of drivers which your system supports
        systemcards = []
        p1 = Popen(['lspci', '-n'], stdout=PIPE)
        p = p1.communicate()[0].split('\n')
        indentifier1 = re.compile('.*0300:.*:(.+) \(.+\)')
        indentifier2 = re.compile('.*0300:.*:(.+)')
        for line in p:#self.completetxt:#self.logged:
            m1 = indentifier1.match(line)
            m2 = indentifier2.match(line)
            if m1:
                id = m1.group(1).strip().lower()
                systemcards.append(id)
            elif m2:
                id = m2.group(1).strip().lower()
                systemcards.append(id)


        for card in systemcards:
            #detect the card and choose the driver accordingly
            if self.cards.setdefault(card, 'N/A') != 'N/A':
                #print 'Your graphic card has been detected as a ' + self.cards[card]
                #print 'Your graphic card is supported by the latest driver'
                drvtype = 'latest'
            elif self.middlecards.setdefault(card, 'N/A') != 'N/A':
                #print 'Your graphic card has been detected as a ' + self.middlecards[card]
                #print 'Your graphic card is supported by the new legacy driver'
                drvtype = 'middle'
            elif self.legacycards.setdefault(card, 'N/A') != 'N/A':
                #print 'Your graphic card has been detected as a ' + self.legacycards[card]
                #print 'Your graphic card is supported by the legacy Driver'
                drvtype = 'oldest'
            else:
                drvtype = 'unsupported'
            availabledrv.append(drvtype)
        if 'latest' in availabledrv:#select the driver following this priority: latest, middle, oldest
            self.details['drvtype'] = 'latest'
        else:
            if 'middle' in availabledrv:
                self.details['drvtype'] = 'middle'
            else:
                if 'oldest' in availabledrv:
                    self.details['drvtype'] = 'oldest'
    
    def atimanver(self):
        while 1:
            drvchoice = raw_input('\n\
                Select the version of the driver which would you like to install:\n\
                1 - ' + atimanlatest + ' (latest)\n\
                2 - ' + atimanlegacy + ' (legacy)\n\
                3 - Back to main menu\n\
                (Type 1, 2 or 3)\n').strip()
            if drvchoice == '1':
                self.details['drvtype'] = 'latest'
                self.details['manualchoice2'] = 'notmenu'
                break
            elif drvchoice == '2':
                self.details['drvtype'] = 'oldest'
                self.details['manualchoice2'] = 'notmenu'
                break
            elif drvchoice == '3':
                self.details['drvtype'] = 'oldest'
                self.details['manualchoice2'] = 'menu'
                break
        if self.details['manualchoice2'] == 'menu':
            objects.mainmenu()
        else:
            self.atireleasenum()

    def nvidiamanver(self):
        while 1:
            drvchoice = raw_input('\n\
                Select the version of the driver which would you like to install:\n\
                1 - ' + nvmanlatest + ' (latest)\n\
                2 - ' + nvmannewlegacy + ' (new legacy)\n\
                3 - ' + nvmanlegacy + ' (legacy)\n\
                4 - Back to main menu\n\
                (Type 1, 2, 3 or 4)\n').strip()
            if drvchoice == '1':
                self.details['drvtype'] = 'latest'
                self.details['manualchoice1'] = 'notmenu'
                break
            elif drvchoice == '2':
                self.details['drvtype'] = 'middle'
                self.details['manualchoice1'] = 'notmenu'
                break
            elif drvchoice == '3':
                self.details['drvtype'] = 'oldest'
                self.details['manualchoice1'] = 'notmenu'
                break
            elif drvchoice == '4':
                self.details['manualchoice1'] = 'menu'
                break
        if self.details['manualchoice1'] == 'menu':
            objects.mainmenu()
        else:
            self.nvreleasenum()

    def manualdetails(self):
        while 1:
            drvchoice = raw_input('\n\
            Select the kind of driver which would you like to install:\n\
            1 - ATI\n\
            2 - NVIDIA\n\
            3 - Back to main menu\n\
            (Type either 1 or 2)\n').strip()
            if drvchoice == '1':
                self.details['cardbrand'] = 'ati'
                self.details['manualchoice'] = 'notmenu'
                break
            elif drvchoice == '2':
                self.details['cardbrand'] = 'nvidia'
                self.details['manualchoice'] = 'notmenu'
                break
            elif drvchoice == '3':
                self.details['manualchoice'] = 'menu'
                break
        if self.details['manualchoice'] == 'menu':
            objects.mainmenu()
        else:
            if self.details['cardbrand'] == 'ati':
                self.atimanver()
            elif self.details['cardbrand'] == 'nvidia':
                self.nvidiamanver()
        
    
    
    def nvreleasenum(self):
        if self.details['drvtype'] == 'latest':
            version = nvmanlatest#100.14.03
            #version = '1.0-' + nvmanlatest#9746
        elif self.details['drvtype'] == 'middle':
            version = '1.0-' + nvmannewlegacy#9631
        elif self.details['drvtype'] == 'oldest':
            version = '1.0-' + nvmanlegacy#7184
        self.details['ver'] = version#add the version of the driver (e.g. '1.0-9746') to the "details" list

    def atireleasenum(self):
        if self.details['drvtype'] == 'latest':
            version = atimanlatest#'8.33.6'
        elif self.details['drvtype'] == 'middle':#doesn't exist
            version = 'none'
        elif self.details['drvtype'] == 'oldest':
            version = atimanlegacy#'8.28.8'
        self.details['ver'] = version#add the version of the driver (e.g. '1.0-9746') to the "details" list

    #FUNCTIONS TO EDIT THE NVIDIA BUILD SCRIPTS

    def strippedver(self):
        if self.details['osname'] not in newmethodos:#LEGACY METHOD
            if self.details['drvtype'] == 'latest':#PLEASE FIX IT
                complete = self.details['ver']
                stripped = complete.split('.')
                completebk = complete#a backup for the version trick
                strippedbk = stripped
                if 0 < int(stripped[-1]) < 10:
                    firstsum = int(stripped[-1]) + 2
                    finalsum = '0' + str(firstsum)
                    trickfirstsum =  int(stripped[-1]) + 1
                    trickfinalsum = '0' + str(firstsum)
                else:
                    finalsum = str(int(stripped[-1]) + 2)
                    trickfinalsum = str(int(stripped[-1]) + 1)
                stripped[-1] = finalsum
                strippedbk[-1] = trickfinalsum
                sep = '.'
                next = sep.join(stripped)
                nextbk = sep.join(strippedbk)
                self.details['strippedver'] = self.details['ver']
                #next = int(complete) + 2
                self.details['nextver'] =  next
                self.details['versiontrick'] = nextbk
            else:
                complete = self.details['ver']
                stripped = complete.split('1.0-')
                stripped.remove('')
                self.details['strippedver'] = stripped[0]#the stripped version of the driver (e.g. 9746)
                next = int(stripped[0]) + 2#the next version of the driver (needed by the Debian scripts)
                self.details['nextver'] =  '1.0.' + str(next)#(e.g. '1.0.9746')

    def nvdistinctionset(self):
        if self.details['osname'] in newmethodos:#NEW METHOD
            kversion = str(os.uname()[2])
            if len(kversion.split('-')) != 1:
                kver1 = kversion.split('-')[0]
                kver2 = kversion.split('-')[1]#abi
                kver3 = kversion.split('-')[2]#generic, 386, lowlatency
                self.nvdistinction = 'linux-restricted-modules-' + kver1
            else:
                self.nvdistinction = 'linux-restricted-modules-' + str(os.uname()[2])
        else:#LEGACY METHOD
            if self.details['drvtype'] != 'oldest':
                self.nvdistinction = 'nvidia-graphics-drivers'
            else:
                self.nvdistinction = 'nvidia-graphics-drivers-legacy'
        

    def renamenvfolder(self):
        check = Shutilities()
        if self.details['osname'] in newmethodos:
            check.cmdoutput('sudo mv /usr/share/envy/linux-restricted-modules-* /usr/share/envy/' + self.nvdistinction, 'noverbose')#e.g. linux-restricted-modules-2.6.22.1


    def upstream(self):
        check = Shutilities()
        if self.details['osname'] not in newmethodos:#USELESS FOR THE NEW METHOD
            if self.details['drvtype'] == 'latest':
                check.cmdoutput('sudo cp /usr/share/envy/nvidia-graphics-drivers/debian/upstreamnew /usr/share/envy/nvidia-graphics-drivers/debian/upstream_info')
            else:
                check.cmdoutput('sudo cp /usr/share/envy/nvidia-graphics-drivers/debian/upstreamold /usr/share/envy/nvidia-graphics-drivers/debian/upstream_info')
            lines = []
            if self.details['drvtype'] == 'oldest':
                file1 = '/usr/share/envy/nvidia-graphics-drivers-legacy/debian/upstream_info'
            else: 
                file1 = '/usr/share/envy/nvidia-graphics-drivers/debian/upstream_info'
            #nvidia-graphics-drivers (1.0.9746-2) unstable; urgency=low
            release = self.details['strippedver']
            next = self.details['nextver']
            pat1 = 'RELEASE=.+(.*)'
            pat2 = 'NEXTVER=.+(.*)'
            line1 = 'RELEASE=' + release + '\n'
            line2 = 'NEXTVER='+ next + '\n'
            replacing = Replacement()
            replacing.replaceline(file1, pat1, line1)
            replacing.replaceline(file1, pat2, line2)

    def changelog(self):
        if self.details['osname'] in newmethodos:#NEW METHOD
            file1 = '/usr/share/envy/' + self.nvdistinction + '/debian/changelog'
            kversion = os.uname()[2]
            opsystem = self.details['osname']
            #nvidia-graphics-drivers (1.0.9746-2) unstable; urgency=low
            #release = '1.0.' + self.details['strippedver'] + '-100'
            pat1 = 'linux-restricted-modules-.* (\(.+\)) (.+); urgency=low'
            #linux-restricted-modules-2.6.22.1 (2.6.22.1) feisty; urgency=low
            if len(kversion.split('-')) != 1:
                kver1 = kversion.split('-')[0]
                kver2 = kversion.split('-')[1]#abi
                kver3 = kversion.split('-')[2]#generic, 386, lowlatency
                line1 = self.nvdistinction + ' (' + kver1 + '-' + kver2 +') ' + opsystem + '; urgency=low\n'
            else:
                line1 = self.nvdistinction + ' (' + kversion + ') ' + opsystem + '; urgency=low\n'
        else:#LEGACY METHOD
            if self.details['drvtype'] == 'oldest':
                file1 = '/usr/share/envy/nvidia-graphics-drivers-legacy/debian/changelog'
            else: 
                file1 = '/usr/share/envy/nvidia-graphics-drivers/debian/changelog'
            #nvidia-graphics-drivers (1.0.9746-2) unstable; urgency=low
            #release = '1.0.' + self.details['strippedver'] + '-100'
            if self.details['drvtype'] != 'latest':
                versiontrick = str(int(self.details['strippedver']) +1)#trick
            if self.details['drvtype'] == 'latest':#beta
                release = '1:' + self.details['versiontrick'] #use the version trick
            else:
                release = '1:1.0.' + versiontrick#use the version trick
            opsystem = self.details['osname']
            if self.details['drvtype'] == 'oldest':
                pat1 = 'nvidia-graphics-drivers-legacy (\(.+\)) (.+); urgency=low'
                line1 = 'nvidia-graphics-drivers-legacy (' + release + ') ' + opsystem + '; urgency=low\n'
            else: 
                pat1 = 'nvidia-graphics-drivers (\(.+\)) (.+); urgency=low'
                line1 = 'nvidia-graphics-drivers (' + release + ') ' + opsystem + '; urgency=low\n'
        replacing = Replacement()
        replacing.replaceline(file1, pat1, line1)

    def changelogsrc(self):
        if self.details['osname'] in newmethodos:#NEW METHOD
            file1 = '/usr/share/envy/' + self.nvdistinction + '/nvidia/debian.binary/changelog'
            if self.details['drvtype'] == 'latest':
                drvver = nvmanlatest
            elif self.details['drvtype'] == 'middle':
                drvver = nvmannewlegacy
            elif self.details['drvtype'] == 'oldest':
                drvver = nvmanlegacy
            kversion = os.uname()[2]
            opsystem = self.details['osname']
            #nvidia-graphics-drivers (1.0.9746-2) unstable; urgency=low
            #release = '1.0.' + self.details['strippedver'] + '-100'
            pat1 = 'nvidia-kernel (\(.+\)) (.+); urgency=low'
            #nvidia-kernel (100.14.11-0ubuntu3) breezy; urgency=low
            #nvidia-kernel-1.0-100.14.11
            #linux-restricted-modules-2.6.22.1 (2.6.22.1) feisty; urgency=low
            if self.details['drvtype'] == 'latest':
                line1 = 'nvidia-kernel (' + drvver + '-0ubuntu3) ' + opsystem + '; urgency=low\n'
            else: line1 = 'nvidia-kernel (1.0.' + drvver + '-0ubuntu3) ' + opsystem + '; urgency=low\n'
            replacing = Replacement()
            replacing.replaceline(file1, pat1, line1)

    def control(self):
        check = Shutilities()
        if self.details['osname'] in newmethodos:#NEW METHOD
            if self.details['osname'] in self.legacyos:#Debian needs this
                deb = 'deb'
            else: deb = ''
            if self.details['drvtype'] == 'latest':
                control = 'controllatest' + deb
                controlstub = 'control.stublatest' + deb
                controlstubin = 'control.stub.inlatest' + deb
            elif self.details['drvtype'] == 'middle':
                control = 'controlmiddle' + deb
                controlstub = 'control.stubmiddle' + deb
                controlstubin = 'control.stub.inmiddle' + deb
            elif self.details['drvtype'] == 'oldest':
                control = 'controloldest' + deb
                controlstub = 'control.stuboldest' + deb
                controlstubin = 'control.stub.inoldest' + deb
            check.cmdoutput('sudo cp /usr/share/envy/' + self.nvdistinction + '/debian/' + control  + ' /usr/share/envy/' + self.nvdistinction + '/debian/control')
            check.cmdoutput('sudo cp /usr/share/envy/' + self.nvdistinction + '/debian/' + controlstub  + ' /usr/share/envy/' + self.nvdistinction + '/debian/control.stub')
            check.cmdoutput('sudo cp /usr/share/envy/' + self.nvdistinction + '/debian/' + controlstubin  + ' /usr/share/envy/' + self.nvdistinction + '/debian/control.stub.in')
            #links
            check.cmdoutput('sudo cp /usr/share/envy/' + self.nvdistinction + '/debian/nvidia-glx.links.amd64.inenvybck  /usr/share/envy/' + self.nvdistinction + '/debian/nvidia-glx.links.amd64.in')
            check.cmdoutput('sudo cp /usr/share/envy/' + self.nvdistinction + '/debian/nvidia-glx.links.inenvybck  /usr/share/envy/' + self.nvdistinction + '/debian/nvidia-glx.links.in')
            check.cmdoutput('sudo cp /usr/share/envy/' + self.nvdistinction + '/debian/nvidia-glx-dev.links.inenvybck  /usr/share/envy/' + self.nvdistinction + '/debian/nvidia-glx-dev.links.in')
        else:#LEGACY METHOD
            if self.details['drvtype'] != 'oldest':
                osdepend = ['dapper']
                file1 = '/usr/share/envy/nvidia-graphics-drivers/debian/control.in'
                #nvidia-graphics-drivers (1.0.9746-2) unstable; urgency=low
                xreleasenew = '>= 1:7.0.0'
                xreleaseold = '>= 7.0.0'#only for Dapper
                pat1 = 'Depends\: nvidia\-kernel\-\#VERSION\#\, x11\-common \((.*)\)\, \$\{shlibs\:Depends\}\n'
                if self.details['osname'] in self.legacyos:
                    release = xreleaseold
                else:
                    release = xreleasenew
                line1 = 'Depends: nvidia-kernel-#VERSION#, x11-common (' + release + '), ${shlibs:Depends}\n'
                replacing = Replacement()
                replacing.replaceline(file1, pat1, line1)

    def nvlinks(self):
        if self.details['osname'] in newmethodos:#NEW METHOD
            if self.details['drvtype'] == 'latest':
                files = ['/usr/share/envy/' + self.nvdistinction + '/debian/nvidia-glx.links.amd64.in', '/usr/share/envy/' + self.nvdistinction + '/debian/nvidia-glx.links.in', '/usr/share/envy/' + self.nvdistinction + '/debian/nvidia-glx-dev.links.in']
                #check.cmdoutput('cat ' + file + ' | sed \'s/@@VERSION@@/100.11.14/g\' > ' + file)
                for file1 in files:
                    pat1 ='@@VERSION@@'
                    line1 = nvmanlatest
                    replacing = Replacement()
                    replacing.replaceelem(file1, pat1, line1)
            else: print 'no need to change nvidia links'

    def controlsrc(self):#nvidia/debian.binary
        if self.details['osname'] in newmethodos:#NEW METHOD
            file1 = '/usr/share/envy/' + self.nvdistinction + '/nvidia/debian.binary/control.template'
            if self.details['drvtype'] == 'latest':
                drvver = nvmanlatest
            elif self.details['drvtype'] == 'middle':
                drvver = nvmannewlegacy
            elif self.details['drvtype'] == 'oldest':
                drvver = nvmanlegacy
            kversion = os.uname()[2]
            opsystem = self.details['osname']
            pat1 = 'Provides: nvidia-kernel-.*\n'
            #nvidia-kernel (100.14.11-0ubuntu3) breezy; urgency=low
            #nvidia-kernel-1.0-100.14.11
            if self.details['drvtype'] == 'latest':
                line1 = 'Provides: nvidia-kernel-' + drvver + '\n'
            else: line1 = 'Provides: nvidia-kernel-1.0.' + drvver + '\n'
            replacing = Replacement()
            replacing.replaceline(file1, pat1, line1)

    def nvrulesver(self):
        if self.details['osname'] in newmethodos:#NEW METHOD
            if self.details['drvtype'] == 'latest':
                drvchoice = '${nv_new_version}'
            elif self.details['drvtype'] == 'middle':
                drvchoice = '${nv_version}'
            elif self.details['drvtype'] == 'oldest':
                drvchoice = '${nv_legacy_version}'
            file1 = '/usr/share/envy/' + self.nvdistinction + '/debian/rules'
            pat1 = 'nv_drv_choice := ' + '.*\n'
            #nv_drv_choice := ${nv_new_release}
            line1 = 'nv_drv_choice := ' + drvchoice + '\n'
            replacing = Replacement()
            replacing.replaceline(file1, pat1, line1)
        else:#LEGACY METHOD
            if self.details['drvtype'] != 'oldest':
                file1 = '/usr/share/envy/nvidia-graphics-drivers/debian/rules'
                #nvidia-graphics-drivers (1.0.9746-2) unstable; urgency=low
                if self.details['drvtype'] == 'latest':
                    release = self.details['strippedver']
                else:
                    release = '1.0.' + self.details['strippedver']
                pat1 = 'latest:=(.+)\n'
                line1 = 'latest:=' + nvmanlatest + '\n'
                replacing = Replacement()
                replacing.replaceline(file1, pat1, line1)
            
    def nvidiapkgmake(self):
        check = Shutilities()
        if self.details['osname'] in newmethodos:#NEW METHOD
            main.newdependencies()#dependencies for Ubuntu scripts
            check.cmdoutput('sudo chmod +x /usr/share/envy/' + self.nvdistinction + '/nvidia/*.run')
            check.cmdoutput('cd /usr/share/envy/' + self.nvdistinction + '/ && sudo dpkg-buildpackage -b -uc')
        else:#LEGACY METHOD
            #if self.details['drvtype'] == 'oldest':
            #    self.nvdistinction = 'nvidia-graphics-drivers-legacy'
            #else:
            #    self.nvdistinction = 'nvidia-graphics-drivers'
            check.cmdoutput('sudo chmod +x /usr/share/envy/' + self.nvdistinction + '/*.run')
            check.cmdoutput('cd /usr/share/envy/' + self.nvdistinction + '/ && sudo dpkg-buildpackage -b -uc')
    
##    def nvidiakcommon(self):#Make sure this file is installed on Etch
##        nvkcommon = []
##        p = os.popen('sudo aptitude show nvidia-kernel-common')
##        indentifier = re.compile('.*State\:(.*)\n')
##        for line in p:#self.completetxt:#self.logged:
##            m1 = indentifier.match(line)
##            if m1:
##                id = m1.group(1).strip().lower()
##                if id == 'installed':
##                    nvkcommon.append('yes')
##        #print nvkcommon
##        if 'yes' not in nvkcommon:
##            print 'ENVY ERROR: nvidia-kernel-common is not installed and cannot be installed!'
##        else:
##            print 'OK: nvidia-kernel-common is installed'
        
    
    def nvpkginstall1(self):
        check = Shutilities()
        drvname = self.details['drvname']
        main.removediversion('libGL.so')
        check.cmdoutput('sudo apt-get install -f -y')
        toinstall = ['nvidia-kernel-common']
        #check.cmdoutput('sudo apt-get install -y nvidia-kernel-common')#needed by Etch
        check.checkntry(toinstall)#this should throw an error and make Envy abort on Etch if needed
        if self.details['osname'] in newmethodos:#NEW METHOD
            toremove = [\
            'nvidia-glx nvidia-glx-dev', \
            'nvidia-glx-new nvidia-glx-new-dev', \
            'nvidia-new-kernel-source', \
            'nvidia-kernel-source', \
            'nvidia-legacy-kernel-source', \
            'nvidia-glx-legacy', \
            'nvidia-settings nvidia-xconfig']
            check.pkgremove(toremove, 'purge')

            #if self.details['osname'] == 'etch':
            #    self.nvidiakcommon()#this should throw an error and make Envy abort on Etch if needed
            if self.details['drvtype'] == 'oldest':#TEMPORARY FIX
                check.checkntry(['nvidia-settings', 'nvidia-xconfig'])
            
            if self.details['drvtype'] == 'latest':
                check.cmdoutput('cd /usr/src/ && sudo rm nvidia*.tar.gz', 'noverbose')
                check.cmdoutput('cd /usr/share/envy/ && sudo dpkg -i nvidia-new-kernel-source*.deb')#verbose
                check.cmdoutput('cd /usr/src/ && sudo tar -xzvf nvidia*')#verbose
            elif self.details['drvtype'] == 'middle':
                check.cmdoutput('cd /usr/src/ && sudo rm nvidia*.tar.gz', 'noverbose')
                check.cmdoutput('cd /usr/share/envy/ && sudo dpkg -i nvidia-kernel-source_*.deb')
                check.cmdoutput('cd /usr/src/ && sudo tar -xzvf nvidia*')
            elif self.details['drvtype'] == 'oldest':
                check.cmdoutput('cd /usr/src/ && sudo rm nvidia*.tar.gz', 'noverbose')
                check.cmdoutput('cd /usr/share/envy/ && sudo dpkg -i nvidia-legacy-kernel-source*.deb')
                check.cmdoutput('cd /usr/src/ && sudo tar -xzvf nvidia*')
        else:#LEGACY METHOD
            #if self.details['osname'] == 'etch':
            #    self.nvidiakcommon()#this should throw an error and make Envy abort on Etch if needed
            if self.details['drvtype'] == 'oldest':#TEMPORARY FIX
                check.checkntry(['nvidia-settings', 'nvidia-xconfig'])
                check.cmdoutput('cd /usr/share/envy/ && sudo dpkg -i nvidia-legacy-kernel-source*.deb')
            else:
                check.cmdoutput('cd /usr/share/envy/ && sudo dpkg -i nvidia-kernel-source_*.deb')

    def nvpkginstall2(self):
        check = Shutilities()
        if self.details['osname'] in newmethodos:#NEW METHOD
            drvname = self.details['drvname']
            #check.cmdoutput('sudo rm /usr/lib/nvidia/libGL.so.1* > /dev/null 2>&1')
            check.cmdoutput('sudo apt-get install -f -y')
            if self.details['drvtype'] == 'latest':
                check.cmdoutput('cd /usr/share/envy/ && sudo dpkg -i nvidia-glx-new_*.deb')
                check.cmdoutput('cd /usr/share/envy/ && sudo dpkg -i nvidia-glx-new-dev_*.deb')
            elif self.details['drvtype'] == 'middle':
                check.cmdoutput('cd /usr/share/envy/ && sudo dpkg -i nvidia-glx_*.deb')
                check.cmdoutput('cd /usr/share/envy/ && sudo dpkg -i nvidia-glx-dev_*.deb')
            elif self.details['drvtype'] == 'oldest':
                check.cmdoutput('cd /usr/share/envy/ && sudo dpkg -i nvidia-glx-legacy_*.deb')
                check.cmdoutput('cd /usr/share/envy/ && sudo dpkg -i nvidia-glx-legacy-dev_*.deb')
        else:#LEGACY METHOD
            drvname = self.details['drvname']
            main.removediversion('libGL.so')
            #check.cmdoutput('sudo rm /usr/lib/nvidia/libGL.so.1* > /dev/null 2>&1')
            check.pkgremove('nvidia-glx-new', 'purge')
            check.cmdoutput('sudo apt-get install -f -y')
            if self.details['drvtype'] == 'oldest':#TEMPORARY FIX
                check.cmdoutput('cd /usr/share/envy/ && sudo dpkg -i nvidia-glx-legacy_*.deb')
            else:
                check.cmdoutput('cd /usr/share/envy/ && sudo dpkg -i nvidia-glx_*.deb')
            check.cmdoutput('sudo ln -sf /usr/lib/libGL.so.1 /usr/lib/libGL.so')
            
    def nvrmdeb(self):
        #Remove any old fglrx debs from /usr/src/: 
        check = Shutilities()
        files = ['/usr/src/nvidia-kernel*.deb', '/usr/src/nvidia-legacy-kernel*.deb', '/usr/src/nvidia-new-kernel*.deb']
        check.removefiles(files, 'noverbose')
##        check.cmdoutput('sudo rm /usr/src/nvidia-kernel*.deb 2>/dev/null')
##        check.cmdoutput('sudo rm /usr/src/nvidia-legacy-kernel*.deb 2>/dev/null')#useful?
##        check.cmdoutput('sudo rm /usr/src/nvidia-new-kernel*.deb 2>/dev/null')
    
    def nvkmod(self):#compile ATI kernel module
        check = Shutilities()
        check.cmdoutput('sudo module-assistant prepare')
        check.cmdoutput('sudo module-assistant update')
        if self.details['osname'] in newmethodos:#NEW METHOD
            if self.details['drvtype'] == 'latest':
                glx = 'nvidia-new-kernel-source'
            elif self.details['drvtype'] == 'middle':
                glx = 'nvidia'
            elif self.details['drvtype'] == 'oldest':
                glx = 'nvidia-legacy-kernel-source'
            check.cmdoutput('sudo module-assistant build ' + glx)#CHECK IF ITS NAME HAS CHANGED
            check.cmdoutput('sudo module-assistant install ' + glx)
            check.cmdoutput('sudo depmod -ae')
        else:#LEGACY METHOD
            if self.details['osname'] != 'etch':
                glx = 'nvidia'
                glxlegacy = 'nvidia-legacy-kernel-source'
            else:
                glx = 'nvidia'
                glxlegacy = 'nvidia-legacy-kernel-source'
            if self.details['drvtype'] != 'oldest':#TEMPORARY FIX
                check.cmdoutput('sudo module-assistant build ' + glx)#CHECK IF ITS NAME HAS CHANGED
                check.cmdoutput('sudo module-assistant install ' + glx)
            else:
                check.cmdoutput('sudo module-assistant build ' + glxlegacy)
                check.cmdoutput('sudo module-assistant install ' + glxlegacy) 
            check.cmdoutput('sudo depmod -ae')
    
    
    def buildclean(self):
        check = Shutilities()
        if self.details['osname'] in newmethodos:#NEW METHOD
            if self.details['drvtype'] == 'latest':
                glx = 'nvidia-glx-new'
                src = 'nvidia-new-kernel'
            elif self.details['drvtype'] == 'middle':
                glx = 'nvidia-glx'
                src = 'nvidia-kernel'
            elif self.details['drvtype'] == 'oldest':
                glx = 'nvidia-glx-legacy'
                src = 'nvidia-legacy-kernel'
            print 'Cleaning the build system:\nNOTE: The following are only warnings\n'
            
            files = ['/usr/share/envy/*.deb', '/usr/share/envy/*.asc', '/usr/share/envy/*.changes', \
            '/usr/share/envy/' + self.nvdistinction + '/*.tar.gz', '/usr/share/envy/' + self.nvdistinction + '/debian/files', \
            'sudo rm /usr/share/envy/' + self.nvdistinction + '/debian/nvidia-glx-new*']
            dirs = ['/usr/share/envy/' + self.nvdistinction + '/NVIDIA-Linux-' + self.details['arch'] + '-' + self.details['ver'] \
            + '-' + self.details['pkg'],'/usr/share/envy/' + self.nvdistinction + '/debian/build/*', \
            'sudo rm -R /usr/share/envy/' + self.nvdistinction + '/debian/' + glx, \
            'sudo rm -R /usr/share/envy/' + self.nvdistinction + '/debian/' + glx + '-dev', \
            'sudo rm -R /usr/share/envy/' + self.nvdistinction + '/debian/' + src + '-source', \
            'sudo rm -R /usr/share/envy/' + self.nvdistinction + '/debian/' + glx + '-ia32', \
            'sudo rm -R /usr/share/envy/' + self.nvdistinction + '/debian/nvidia/NVIDIA-*pkg1', \
            'sudo rm -R /usr/share/envy/' + self.nvdistinction + '/debian/nvidia/NVIDIA-*pkg2', \
            'sudo rm -R /usr/share/envy/' + self.nvdistinction + '/nvidia/NVIDIA-*pkg1', \
            'sudo rm -R /usr/share/envy/' + self.nvdistinction + '/nvidia/NVIDIA-*pkg2', \
            'sudo rm -R /usr/share/envy/' + self.nvdistinction + '/*.changes']
            check.removefiles(files, 'noverbose')
            check.removedirs(dirs, 'noverbose')
            
            
            
            #check.cmdoutput('sudo rm /usr/share/envy/' + self.nvdistinction + '/debian/' + glx + '.postinst.debhelper 2>/dev/null')
            #check.cmdoutput('sudo rm /usr/share/envy/' + self.nvdistinction + '/debian/' + glx + '.postrm.debhelper 2>/dev/null')
            #check.cmdoutput('sudo rm /usr/share/envy/' + self.nvdistinction + '/debian/' + glx + '.prerm.debhelper 2>/dev/null')
            #check.cmdoutput('sudo rm /usr/share/envy/' + self.nvdistinction + '/debian/' + glx + '.substvars 2>/dev/null')
            #check.cmdoutput('sudo rm /usr/share/envy/' + self.nvdistinction + '/debian/' + glx + '.substvars.bak 2>/dev/null')

            print 'The build system is now clean'
        else:#LEGACY METHOD
            if self.details['drvtype'] == 'oldest':
                #self.nvdistinction = 'nvidia-graphics-drivers-legacy'
                glx = 'nvidia-glx-legacy'
                src = 'nvidia-legacy-kernel'
            else: 
                #self.nvdistinction = 'nvidia-graphics-drivers'
                glx = 'nvidia-glx'
                src = 'nvidia-kernel'
            print 'ENVY: Cleaning the build system\n'
            files = [\
            '/usr/share/envy/*.deb', \
            '/usr/share/envy/*.asc', \
            '/usr/share/envy/*.changes', \
            '/usr/share/envy/' + self.nvdistinction + '/*stamp', \
            '/usr/share/envy/' + self.nvdistinction + '/*.tar.gz', \
            '/usr/share/envy/' + self.nvdistinction + '/debian/files', \
            '/usr/share/envy/' + self.nvdistinction + '/debian/' + glx + '.postinst.debhelper', \
            '/usr/share/envy/' + self.nvdistinction + '/debian/' + glx + '.postrm.debhelper', \
            '/usr/share/envy/' + self.nvdistinction + '/debian/' + glx + '.prerm.debhelper', \
            '/usr/share/envy/' + self.nvdistinction + '/debian/' + glx + '.substvars', \
            '/usr/share/envy/' + self.nvdistinction + '/debian/' + glx + '.substvars.bak']
            dirs = [\
            '/usr/share/envy/' + self.nvdistinction + '/NVIDIA-Linux-' + self.details['arch'] + '-' + self.details['ver'] + '-' + self.details['pkg'], \
            '/usr/share/envy/' + self.nvdistinction + '/debian/' + glx , \
            '/usr/share/envy/' + self.nvdistinction + '/debian/' + glx + '-dev', \
            '/usr/share/envy/' + self.nvdistinction + '/debian/' + src + '-source', \
            '/usr/share/envy/' + self.nvdistinction + '/debian/' + glx + '-ia32']
            check.removefiles(files, 'noverbose')
            check.removedirs(dirs, 'noverbose')
            print 'The build system is now clean'

    def nvpkg(self):#There's no such thing for ATI cards
        if self.details['osname'] in newmethodos:#NEW METHOD
            if self.details['arch'] == 'x86':#arca
                pkg = 'pkg1' #pkg1
            elif self.details['arch'] == 'x86_64':
                pkg = 'pkg2'#paca
        else:#LEGACY METHOD
            if self.details['arch'] == 'x86':#arca
                pkg = 'pkg0' #pkg1
            elif self.details['arch'] == 'x86_64':
                pkg = 'pkg2'#paca
        self.details['pkg'] = pkg

    def nvvarsum(self):#md5
        if self.details['osname'] in newmethodos:#NEW METHOD
            if self.details['arch'] == 'x86':#pkg1
                if self.details['drvtype'] == 'latest':
                    md5old = '3e76376b5f1a53e0c18694fa65691c75'#af434d27f9b089ac1cb216f55f9b0f33#575f988468f2c34a302da3d21e282689
                elif self.details['drvtype'] == 'middle':#up to 96xx
                    md5old = 'b277a5a05f6e8e4e0cd388ea9203e4f5'#3d8b8b700a0c5a34eb39c8ca70a57f72#
                else: md5old = 'f382af60e932449e5e301f1b424d883f'#Legacy
        else:#LEGACY METHOD
            if self.details['arch'] == 'x86':#pkg0
                if self.details['drvtype'] == 'latest':
                    md5old = 'af434d27f9b089ac1cb216f55f9b0f33'#575f988468f2c34a302da3d21e282689#cf0cdbd9099a6df028de429044e7f4da
                elif self.details['drvtype'] == 'middle':#up to 96xx
                    md5old = '3d8b8b700a0c5a34eb39c8ca70a57f72'#b0d721c962c4df1a028ae18416d7e862#3676f622897d22f1815365b44139899e
                else: md5old = '5bba3ec9075a42b33bf51b431123cc15'#Legacy
        
        if self.details['arch'] == 'x86_64':#pkg2 the same for both methods
            if self.details['drvtype'] == 'latest':
                md5old = '060dfcab02bc903ce6f18da4fad6f74f'#c0afc66e1c21a9a54ba6719b8edd3166
            elif self.details['drvtype'] == 'middle':#up to 96xx
                md5old = 'c84db1dd38a965e9074e14f59ecd2331'#64b88c6f405e7f2dd1607c0062c0c1f3
            else: md5old = 'cdca6c2eb474717935b76dd50c22323f'#332850387c4e7a4619753b856e3199e5#Legacy
        self.details['md5old'] = md5old


    def ativarsum(self):#md5
        #arca = architecture()
        if self.details['arch'] == 'x86':
            if self.details['drvtype'] == 'latest':
                md5old = '0d04bccfc0baf8defafa8f66b53a0ef6'#9d890ca2d84b0dd1f18f48d8035f2e3e
            elif self.details['drvtype'] == 'middle':#there's no middle driver for ATI
                md5old = 'none'
            else: md5old = '58189d7cc3625e399b1a434df893100f'#32 bit Legacy
        elif self.details['arch'] == 'x86_64':
            if self.details['drvtype'] == 'latest':
                md5old = '0d04bccfc0baf8defafa8f66b53a0ef6'#9d890ca2d84b0dd1f18f48d8035f2e3e#the same as 32bit
            elif self.details['drvtype'] == 'middle':#there's no middle driver for ATI
                md5old = 'none'
            else: md5old = '58189d7cc3625e399b1a434df893100f'#64bit Legacy
        self.details['md5old'] = md5old
        
 
    '''THE OBJECT WILL CHOOSE THE FUNCTION TO CALL ACCORDING TO THE DRIVER'''
    def nvpkgname(self):#the name of the Nvidia installer
        driver = 'NVIDIA-Linux-' + self.details['arch'] + '-' + self.details['ver'] + '-' + self.details['pkg'] + '.run'#architecture,version,pkg
        self.details['drvname'] = driver

    def atipkgname(self):
        if self.details['drvtype'] == 'oldest':#the name of the OLD ATI installer
            driver = 'ati-driver-installer-' + self.details['ver'] + '.run'#version
        else:#the name of the NEW ATI installer
            driver = 'ati-driver-installer-' + self.details['ver'] + '-x86.x86_64.run'#version
        self.details['drvname'] = driver
    
    def nvftpfolder(self):
        nvidiaftp = 'Linux-' + self.details['arch'] + '/' + self.details['ver']
        self.details['nvftpdir'] = nvidiaftp
    '''
    IF THE LEGACY DRIVER IS SELECTED THE OBJECT SHOULD USE NVOLDADDR
    '''
    def nvaddress(self):
        wsite = ' http://us.download.nvidia.com/XFree86/'
        nvweb = wsite + self.details['nvftpdir'] + '/' + self.details['drvname']
        self.details['website'] = nvweb

   
    def atiaddress(self):
        if self.details['drvtype'] == 'oldest' and self.details['arch'] == 'x86_64':#ONLY for the Legacy driver
            atiweb = ' https://a248.e.akamai.net/f/674/9206/0/www2.ati.com/drivers/linux/64bit/' + self.details['drvname']
        else: atiweb = ' https://a248.e.akamai.net/f/674/9206/0/www2.ati.com/drivers/linux/' + self.details['drvname']
        self.details['website'] = atiweb
    
    def md5get(self):
        cksum = os.popen('md5sum ' + self.details['driverpath'] + self.details['drvname'])
        pat1 = re.compile('(.+)  (.*)\n')
        optext = cksum.readlines()
        for line in optext:
            m1 = pat1.match(line)
            md5 = m1.group(1).strip()
            if m1:
                self.details['md5new'] = md5
    
    def getdriver(self):
        check = Shutilities()
        if self.details['osname'] in newmethodos:#NEW METHOD
            if self.details['cardbrand'] == 'nvidia':
                self.details['driverpath'] = '/usr/share/envy/' + self.nvdistinction + '/nvidia/'
            else:#if ATI
                self.details['driverpath'] = '/usr/share/envy/'
        else:#LEGACY METHOD
            if self.details['cardbrand'] == 'nvidia':
                if self.details['drvtype'] == 'oldest':
                    self.details['driverpath'] = '/usr/share/envy/nvidia-graphics-drivers-legacy/'
                else:#for latest and middle
                    self.details['driverpath'] = '/usr/share/envy/nvidia-graphics-drivers/'
            else:#if ATI
                self.details['driverpath'] = '/usr/share/envy/'
                
        driverlocation = self.details['driverpath'] + self.details['drvname']
        driverexists = os.path.isfile(driverlocation)
        if driverexists:
            print 'An installer has been detected'
            self.md5get()
            print 'md5new: ' + self.details['md5new']#md5new
            print 'md5sumold: ' + self.details['md5old']
            if self.details['md5new'] != self.details['md5old']: #md5new 
                print 'ENVY ERROR: md5 Error! Trying to fetch the driver from the website'
                os.remove(self.details['driverpath'] + self.details['drvname'])
                self.getdriver()#CHECK
        else:#If the driver installer can't be found on your hard disk
            print 'No installer detected'
            print 'Download of the driver in progress, please wait'
            check.cmdoutput('cd ' + self.details['driverpath'] + '&& sudo wget -c --tries=2 --timeout=20 --no-check-certificate' + self.details['website'])
            self.md5get()
            print 'md5new: ' + self.details['md5new']#md5new
            print 'md5sumold: ' + self.details['md5old']
            if self.details['md5new'] != self.details['md5old']:
                print 'ENVY ERROR: md5 Error! Operation aborted'
                sys.exit()


    def atipkgmake(self):
        check = Shutilities()
        a = os.uname()[2]
        b = list(a)
        c1 = a[0:6]
        c = c1.strip()
        kernels1 = ['2.6.13', '2.6.12', '2.6.11', '2.6.10', '2.6.14', '2.6.15', '2.6.16', '2.6.17', '2.6.18', '2.6.19']
        kernels2 = ['2.6.20', '2.6.21', '2.6.22']#needs the patch
        if self.details['osname'] not in self.legacyos:#only dapper and etch use bash
            check.cmdoutput('sudo ln -sf /bin/bash /bin/sh')#can cause problems on Dapper
            check.cmdoutput('sh ' + self.details['drvname'] + ' --buildpkg Ubuntu/' + self.details['osname'])#name of the installer, dapper or edgy
            check.cmdoutput('sudo ln -sf /bin/dash /bin/sh')#can cause problems on Dapper
        else:
            if self.details['osname'] == 'etch':#FIX ME
                check.cmdoutput('sh ' + self.details['drvname'] + ' --buildpkg Debian/' + self.details['osname'])#name of the installer, dapper or edgy
            else:
                check.cmdoutput('sh ' + self.details['drvname'] + ' --buildpkg Ubuntu/' + self.details['osname'])#name of the installer, dapper or edgy

    def atipkginstall(self):
        check = Shutilities()
        drvname = self.details['drvname']
        check.cmdoutput('sudo dpkg -i *.deb')
    
    def atirmdeb(self):
        #Remove any old fglrx debs from /usr/src/: 
        check = Shutilities()
        files = ['/usr/src/fglrx-kernel*.deb']
        check.removefiles(files, 'noverbose')
        ##check.cmdoutput('sudo rm /usr/src/fglrx-kernel*.deb 2>/dev/null')
    
    def atikmod(self):#compile ATI kernel module
        check = Shutilities()
        check.cmdoutput('sudo module-assistant prepare')
        check.cmdoutput('sudo module-assistant update')
        check.cmdoutput('sudo module-assistant build fglrx')
        check.cmdoutput('sudo module-assistant install fglrx')
        check.cmdoutput('sudo depmod -ae')
    
    def nvkernelcontrol(self):#ONLY FOR nvidiaclean
        check = Shutilities()
        a = os.uname()[2]
        b = list(a)
        c1 = a[0:6]
        c = c1.strip()
        kernels1 = ['2.6.13', '2.6.12', '2.6.11', '2.6.10']#gcc-3.4
        kernels2 = ['2.6.14', '2.6.15', '2.6.16', '2.6.17', '2.6.18', '2.6.19', '2.6.20', '2.6.21', '2.6.22']#gcc-4.0 or 4.1
        systemname = self.details['osname']
        if systemname == 'dapper':
            if c in kernels1:
                check.cmdoutput('sudo ln -sf /usr/bin/gcc-3.4 /usr/bin/gcc')
            elif c in kernels2:
                check.cmdoutput('sudo ln -sf /usr/bin/gcc-4.0 /usr/bin/gcc')
        if systemname == 'edgy' or systemname == 'etch':
            if c in kernels1:
                check.cmdoutput('sudo ln -sf /usr/bin/gcc-3.4 /usr/bin/gcc')
            elif c in kernels2:
                check.cmdoutput('sudo ln -sf /usr/bin/gcc-4.1 /usr/bin/gcc')
    
        d = '/usr/src/' + 'kernel-headers-' + a#kernel headers path
        f = '/usr/lib/xorg/modules'#xorg 32bit modules path
        g = '/usr/lib64/xorg/modules'#xorg 64bit modules path
        if os.path.isdir(d):
            '''If the kernel is recompiled'''
            print 'Recompiled kernel detected'
            #self.details['kerneltype'] = 'recompiled'#THE KERNEL IS RECOMPILED
            z = d + '/arch/i386/'
            if not os.path.isdir(z):
                check.cmdoutput('sudo mkdir -p' + ' ' + z)
            if not os.path.isfile(z + 'Makefile.cpu'):
                '''If the Makefile.cpu does not exist'''
                if self.details['arch'] == 'x86_64':
                    main.addmakefile64()
                else: main.addmakefile32()
                check.cmdoutput('cd ' + d + ' && ' + 'sudo make prepare' + ' && ' + 'sudo make prepare scripts')
                if not os.path.isfile(z + 'Makefile.cpu'):
                    '''If the Makefile.cpu still does not exist'''
                    print 'ENVY ERROR: Makefile.cpu not found!'
                    sys.exit()
            if self.details['arch'] == 'x86_64':
                '''For Ubuntu 64bit'''
                check.cmdoutput('sudo sh ' + self.details['drvname'] + ' -n -s --x-prefix=' + g + ' --kernel-source-path=' + d)
            else:
                check.cmdoutput('sudo sh ' + self.details['drvname'] + ' -n -s --x-prefix=' + f + ' --kernel-source-path=' + d)
        else:
            '''For Ubuntu default kernels'''
            #self.details['kerneltype'] = 'default'#THE KERNEL IS NOT RECOMPILED
            e = '/usr/src/' + 'linux-headers-' + a
            if self.details['arch'] == 'x86_64':
                '''For Ubuntu 64bit'''
                check.cmdoutput('sudo sh ' + self.details['drvname'] + ' -n -s --x-prefix=' + g + ' --kernel-source-path=' + e)
            else:
                check.cmdoutput('sudo sh ' + self.details['drvname'] + ' -n -s --x-prefix=' + f + ' --kernel-source-path=' + e)
        check.cmdoutput('sudo depmod -ae')#DEPMOD
    
    def newkernelcontrol(self):
        check = Shutilities()
        a = os.uname()[2]
        b = list(a)
        c1 = a[0:6]
        c = c1.strip()
        kernels1 = ['2.6.13', '2.6.12', '2.6.11', '2.6.10']#gcc-3.4
        kernels2 = ['2.6.14', '2.6.15', '2.6.16', '2.6.17', '2.6.18', '2.6.19', '2.6.20', '2.6.21', '2.6.22']#gcc-4.0 or 4.1
        systemname = self.details['osname']
        if systemname == 'dapper':
            if c in kernels1:
                check.cmdoutput('sudo ln -sf /usr/bin/gcc-3.4 /usr/bin/gcc')
            elif c in kernels2:
                check.cmdoutput('sudo ln -sf /usr/bin/gcc-4.0 /usr/bin/gcc')
        if systemname == 'edgy':
            if c in kernels1:
                check.cmdoutput('sudo ln -sf /usr/bin/gcc-3.4 /usr/bin/gcc')
            elif c in kernels2:
                check.cmdoutput('sudo ln -sf /usr/bin/gcc-4.1 /usr/bin/gcc')
    
        d = '/usr/src/' + 'kernel-headers-' + a#kernel headers path
        f = '/usr/lib/xorg/modules'#xorg 32bit modules path
        g = '/usr/lib64/xorg/modules'#xorg 64bit modules path
        if os.path.isdir(d):
            '''If the kernel is recompiled'''
            print 'Recompiled kernel detected'
            #self.details['kerneltype'] = 'recompiled'#THE KERNEL IS RECOMPILED
            z = d + '/arch/i386/'
            if not os.path.isdir(z):
                check.cmdoutput('sudo mkdir -p' + ' ' + z)
            if not os.path.isfile(z + 'Makefile.cpu'):
                '''If the Makefile.cpu does not exist'''
                if self.details['arch'] == 'x86_64':
                    main.addmakefile64()
                else: main.addmakefile32()
                check.cmdoutput('cd ' + d + ' && ' + 'sudo make prepare' + ' && ' + 'sudo make prepare scripts')
                if not os.path.isfile(z + 'Makefile.cpu'):
                    '''If the Makefile.cpu still does not exist'''
                    print 'ENVY ERROR: Makefile.cpu not found!'
                    sys.exit()

    
    def nvuninstalling(self):
        check = Shutilities()
        if self.details['osname'] in newmethodos:#NEW METHOD
            check.cmdoutput('cd /usr/share/envy/' + self.nvdistinction + '/nvidia/ && sudo sh ' + self.details['drvname'] + ' --uninstall')
        else:#LEGACY METHOD
            #if self.details['drvtype'] == 'oldest':
            #    self.nvdistinction = 'nvidia-graphics-drivers-legacy'
            #else: 
            #    self.nvdistinction = 'nvidia-graphics-drivers'
            check.cmdoutput('cd /usr/share/envy/' + self.nvdistinction + '/ && sudo sh ' + self.details['drvname'] + ' --uninstall')
        #in common
        if self.details['osname'] != 'etch':
            check.cmdoutput('sudo apt-get -y install --reinstall linux-restricted-modules-`uname -r`')

    
    def xorgbackup(self):
        check = Shutilities()
        check.cmdoutput('sudo cp /etc/X11/xorg.conf /etc/X11/xorg.conf_backup_`date +%Y%m%d%H%M`')
    
    #FUNCTIONS TO SOLVE THE PROBLEM WITH RESTRICTED DRIVERS MANAGER
    def blacklistlrm(self):#Blacklist
        oldoslist = ['dapper', 'edgy', 'etch']
        if self.details['osname'] not in oldoslist:
            blist = Rdrvmanager()
            blist.init()
            blist.action = 'blacklist'
            blist.actionlist()
    
    def deblacklistlrm(self):#Blacklist
        oldoslist = ['dapper', 'edgy', 'etch']
        if self.details['osname'] not in oldoslist:
            blist = Rdrvmanager()
            blist.init()
            blist.action = 'deblacklist'
            blist.actionlist()
    
    def restoregcc(self):
        check = Shutilities()
        a = os.uname()[2]
        b = list(a)
        c1 = a[0:6]
        c = c1.strip()
        kernels1 = ['2.6.13', '2.6.12', '2.6.11', '2.6.10']#gcc-3.4
        kernels2 = ['2.6.14', '2.6.15', '2.6.16', '2.6.17', '2.6.18', '2.6.19', '2.6.20', '2.6.21', '2.6.22']#gcc-4.0 or 4.1
        systemname = self.details['osname']
        if systemname == 'dapper':
            if c in kernels1:
                check.cmdoutput('sudo ln -sf /usr/bin/gcc-3.4 /usr/bin/gcc')
            elif c in kernels2:
                check.cmdoutput('sudo ln -sf /usr/bin/gcc-4.0 /usr/bin/gcc')
        if systemname == 'edgy' or systemname == 'etch':
            if c in kernels1:
                check.cmdoutput('sudo ln -sf /usr/bin/gcc-3.4 /usr/bin/gcc')
            elif c in kernels2:
                check.cmdoutput('sudo ln -sf /usr/bin/gcc-4.1 /usr/bin/gcc')
    
    def nviconadd(self):
         try:
             shutil.copy('/usr/share/envy/nvidia-settings.desktop', '/usr/share/applications/')
         except OSError:
            pass
    
    def nviconrm(self):
         a = os.path.isfile('/usr/share/applications/nvidia-settings.desktop')
         try:
             os.remove('/usr/share/applications/nvidia-settings.desktop')
         except OSError:
            pass
    
    def xorgset(self):
        answer = raw_input('Do you want your xorg.conf to be automatically configured? (y/n) \ "y" is the default answer\n').strip().lower()
        while 1:
            if answer == 'y' or answer == '':
                self.xorgreply = 'y'
                break
                #return 'y'
            elif answer == 'n':
                #return 'n'
                self.xorgreply = 'n'
                break
    
    def nvxorgset(self):
        check = Shutilities()
        distrolst = ['edgy', 'etch', 'feisty']#THEY NEED COMPOSITE TO BE ENABLED ATM
        systemname = self.details['osname']
        if systemname in distrolst:
            if self.details['drvtype'] == 'latest' or self.details['drvtype'] == 'middle':
                check.cmdoutput('sudo /usr/bin/nvidia-xconfig --composite')#MAKE SURE that COMPOSITE is ENABLED
                try:
                    if self.details['geforcego'] == 'true':#needed by geforce go 420 440
                        check.cmdoutput('sudo /usr/share/envy/legacy/nvidia-xconfig --use-display-device=DFP')
                except KeyError:
                    pass
            else:
                check.cmdoutput('sudo /usr/share/envy/legacy/nvidia-xconfig --no-composite')#MAKE SURE that COMPOSITE is DISABLED
        else:  check.cmdoutput('sudo /usr/share/envy/legacy/nvidia-xconfig')#for Dapper

    
    def atixorgset(self):
        distrolst = ['edgy', 'etch', 'feisty']#THEY NEED COMPOSITE and AIGLX TO BE DISABLED ATM
        systemname = self.details['osname']
        objects.disablecomposite()
        runme = Fglrx()
        runme.file = '/etc/X11/xorg.conf'
        runme.atifglrx()
        


class Fglrx:
    def atifglrx(self):
        drvlst = ['fbdev', 'vga', 'vesa', 'radeon', 'ati', 'fglrx']
        lines = []
        text = open(self.file, 'r')
        optext = text.readlines()
        pat1 = re.compile('.*Driver.*\"(.+)\".*\n')
        for line in optext:
            m1 = pat1.match(line)
            if m1:
                drvstring = m1.group(1).strip()
                if drvstring in drvlst:
                    line = 	'\tDriver\t\"fglrx\"\n'
                lines.append(line)
            else:
                lines.append(line)
        text.close()
        sep = ''
        modtext = open(self.file, 'w')
        a = sep.join(lines)
        modtext.write(a)
        modtext.close()

        lines1 = []
        text1 = open(self.file, 'r')
        optext1 = text1.readlines()
        pat2 = re.compile('.*Option.*\"VideoOverlay\".*\".+\".*\n')
        pat3 = re.compile('.*Option.*\"OpenGLOverlay\".*\".+\".*\n')
        for line in optext1:
            m2 = pat2.match(line)
            m3 = pat3.match(line)
            if m2:
                line = 	''
                lines1.append(line)
            elif m3:
                line = ''#a bookmark to find the 3rd line we need to delete
                lines1.append(line)
            else:
                lines1.append(line)
        text1.close()
        sep = ''
        modtext1 = open(self.file, 'w')
        a = sep.join(lines1)
        modtext1.write(a)
        modtext1.close()
        
        lastlines = []
        lasttext = open(self.file, 'r')
        newtext = lasttext.readlines()
        pat4 = re.compile('.*Driver.*\"fglrx\".*\n')#removes what remains of the option
        for lastline in newtext:
            m4 = pat4.match(lastline)
            if m4:
                lastline = '\tDriver\t\"fglrx\"\n\tOption\t\"VideoOverlay\" \"on\"\n\tOption\t\"OpenGLOverlay" "off"\n'
                lastlines.append(lastline)
            else: lastlines.append(lastline)
        lasttext.close()
        modtext2 = open(self.file, 'w')
        b = sep.join(lastlines)
        modtext2.write(b)
        modtext2.close()


class Composite:#removes any trace of the Composite Extension

    def operate(self):
        lines = []
        pat1 = re.compile('.*Section.*\"Extensions\".*\n')
        pat2 = re.compile('.*Option.*\"Composite\".*\"(.+)\".*\n')
        text = open(self.file, 'r')
        optext = text.readlines()
        for line in optext:
            m1 = pat1.match(line)
            m2 = pat2.match(line)
            if m1:
                line = ''
                lines.append(line)
            elif m2:
                line = '>'#a bookmark to find the 3rd line we need to delete
                lines.append(line)
            else:
                lines.append(line)
        text.close()
        sep = ''
        modtext = open(self.file, 'w')
        a = sep.join(lines)
        modtext.write(a)
        modtext.close()
        
        lastlines = []
        lasttext = open(self.file, 'r')
        newtext = lasttext.readlines()
        pat3 = re.compile('>.*EndSection.*\n')#removes what remains of the option
        for lastline in newtext:
            m3 = pat3.match(lastline)
            if m3:
                lastline = ''
                lastlines.append(lastline)
            else: lastlines.append(lastline)
        lasttext.close()
        modtext1 = open(self.file, 'w')
        b = sep.join(lastlines)
        modtext1.write(b)
        modtext1.close()

class Compositechoice:
    #def init():
    #    self.file = 'none'#the address of the file
    #    self.operation = 'none'#Disable or Enable
    
    def choosecomposite(self):#Enable or Disable Composite
        objects.removecomposite()
        file = open(self.file, 'a')
        option = '\nSection "Extensions"\n\tOption "Composite" "' + self.operation + '"\nEndSection\n\n'
        file.write(option)
        file.close()

'''DE\BLACKLIST FGLRX OR NVIDIA'''
class Chooselist:
    def init(self):
        self.driver = 'none'#'fglrx', 'nvidia' or ''
    def blacklist(self):
        '''restore Ubuntu original linux-restricted-modules-common'''
        restrictedblk = open('/etc/default/linux-restricted-modules-common', 'w')
        restrictedblk.write('# This file is sourced from the linux-restricted-modules-common init\n\
# script and is used to disable the link-on-boot feature, one module\n\
# at a time.  This can be useful if you want to use hand-compiled\n\
# versions of one or more modules, but keep linux-restricted-modules\n\
# installed on your system, or just to disable modules you don\'t use\n\
# and speed up your boot process by a second or two.\n\
#\n\
# Use a space-separated list of modules you wish to not have linked\n\
# on boot.  The following example shows a (condensed) list of all\n\
# modules shipped in the linux-restricted-modules packages:\n\
#\n\
# DISABLED_MODULES="ath_hal fc fglrx ltm nv"\n\
#\n\
# Note that disabling "fc" disables all fcdsl drivers, "ltm" disables\n\
# ltmodem and ltserial, and "nv" disables both the nvidia drivers.\n\
# You can also name each module individually, if you prefer a subset.\n\
\n\
DISABLED_MODULES="' + self.driver + '"\n')
        restrictedblk.close()


