#!/usr/bin/env python
#Developed by Alberto Milone (aka tseliot)

import sys
import commands
import string
import os, popen2, fcntl, fcntl, select
from os.path import isfile
import shutil
import classes #instun/classes.py
import interfaceclasses
import objects
import main
import fileinput, re

'''NVIDIA CARDS'''
'''Cards supported by the latest driver'''
def nvnewcards():
    cards = {'0323': 'GeForce FX 5200LE', '031c': 'Quadro FX Go700', '004e': 'Quadro FX 4000', '00f6': 'GeForce 6800 GS/XT', '00f4': 'GeForce 6600 LE', '00f5': 'GeForce 7800 GS', '00f2': 'GeForce 6600', '00f3': 'GeForce 6200', '0428': 'GeForce 8400M G', '0429': 'uadro NVS 140M', '0426': 'GeForce 8400M GT', '0427': 'GeForce 8400M GS', '0425': 'GeForce 8600M GS', '0422': 'GeForce 8400 GS', '0423': 'GeForce 8300 GS', '00f8': 'Quadro FX 4400/Quadro FX 3400', '00f9': 'GeForce 6800 Ultra', '0141': 'GeForce 6600', '0140': 'GeForce 6600 GT', '0143': 'GeForce 6600 VE', '0142': 'GeForce 6600 LE', '0145': 'GeForce 6610 XL', '0144': 'GeForce Go 6600', '0147': 'GeForce 6700 XL', '0146': 'GeForce Go 6600 TE/6200 TE', '0149': 'GeForce Go 6600 GT', '0148': 'GeForce Go 6600', '0302': 'GeForce FX 5800', '0301': 'GeForce FX 5800 Ultra', '0048': 'GeForce 6800 XT', '0040': 'GeForce 6800 Ultra', '0041': 'GeForce 6800', '0042': 'GeForce 6800 LE', '0043': 'GeForce 6800 XE', '0044': 'GeForce 6800 XT', '0045': 'GeForce 6800 GT', '0046': 'GeForce 6800 GT', '0047': 'GeForce 6800 GS', '014a': 'Quadro NVS 440', '014c': 'Quadro FX 540M/Quadro FX 540M', '014e': 'Quadro FX 540', '014d': 'Quadro FX 550', '014f': 'GeForce 6200', '00ff': 'GeForce PCX 4300', '00fd': 'Quadro NVS 280 PCI-E/Quadro FX 330', '00fe': 'Quadro FX 1300', '00fb': 'GeForce PCX 5900', '00fc': 'Quadro FX 330', '00fa': 'GeForce PCX 5750', '0332': 'GeForce FX 5900XT', '0333': 'GeForce FX 5950 Ultra', '042d': 'Quadro FX 360M', '0331': 'GeForce FX 5900', '042b': 'Quadro NVS 135M', '0334': 'GeForce FX 5900ZT', '042a': 'Quadro NVS 130M', '01d1': 'GeForce 7300 LE', '01d0': 'GeForce 7350 LE', '01d3': 'GeForce 7300 SE/7200 GS', '0326': 'GeForce FX 5500', '0321': 'GeForce FX 5200 Ultra', '0320': 'GeForce FX 5200', '01d7': 'Quadro NVS 110M', '01d6': 'GeForce Go 7200', '01d8': 'GeForce Go 7400', '0328': 'GeForce FX Go5200 32M/64M', '019d': 'Quadro FX 5600', '019e': 'Quadro FX 4600', '029a': 'Quadro FX 2500M', '029c': 'Quadro FX 5500', '029b': 'Quadro FX 1500M', '029e': 'Quadro FX 1500', '029d': 'Quadro FX 3500', '029f': 'Quadro FX 4500 X2', '0241': 'GeForce 6150 LE', '0330': 'GeForce FX 5900 Ultra', '0299': 'GeForce Go 7900 GTX', '0298': 'GeForce Go 7900 GS', '00f0': 'GeForce 6800 Ultra/GeForce 6800', '0291': 'GeForce 7900 GT/GTO', '0290': 'GeForce 7900 GTX', '0293': 'GeForce 7950 GX2', '0292': 'GeForce 7900 GS', '0295': 'GeForce 7950 GT', '0294': 'GeForce 7950 GX2', '0297': 'GeForce Go 7950 GTX', '0211': 'GeForce 6800', '032d': 'GeForce FX Go5100', '01dc': 'Quadro FX 350M', '0212': 'GeForce 6800 LE', '0215': 'GeForce 6800 GT', '01dd': 'GeForce 7500 LE', '032c': 'GeForce FX Go53xx', '01df': 'GeForce 7300 GS', '0218': 'GeForce 6800 XT', '0191': 'GeForce 8800 GTX', '02e1': 'GeForce 7600 GS', '02e0': 'GeForce 7600 GT/Unknown GPU', '0194': 'GeForce 8800 Ultra', '02e2': 'GeForce 7300 GS', '00f1': 'GeForce 6600 GT', '016a': 'GeForce 7100 GS', '0421': 'GeForce 8500 GT', '0343': 'GeForce FX 5700LE', '0342': 'GeForce FX 5700', '0341': 'GeForce FX 5700 Ultra', '0347': 'GeForce FX Go5700', '0344': 'GeForce FX 5700VE', '00ce': 'Quadro FX 1400', '00cd': 'Quadro FX 3450/4000 SDI', '0348': 'GeForce FX Go5700', '053b': 'GeForce 7050 PV / NVIDIA nForce 630a', '00cc': 'Quadro FX Go1400', '053e': 'GeForce 7025 / NVIDIA nForce 630a', '0242': 'GeForce 6100', '0240': 'GeForce 6150', '0168': 'GeForce Go 6400', '0309': 'Quadro FX 1000', '0244': 'GeForce Go 6150', '0245': 'Quadro NVS 210S / NVIDIA GeForce 6150LE', '0163': 'GeForce 6200 LE', '0162': 'GeForce 6200SE TurboCache(TM)', '0161': 'GeForce 6200 TurboCache(TM)', '0160': 'GeForce 6500', '0167': 'GeForce Go 6200', '0166': 'GeForce Go 6400', '0165': 'Quadro NVS 285', '0164': 'GeForce Go 6200', '034c': 'Quadro FX Go1000', '00c9': 'GeForce Go 6800 Ultra', '00c8': 'GeForce Go 6800', '034e': 'Quadro FX 1100', '00c1': 'GeForce 6800', '00c0': 'GeForce 6800 GS', '00c3': 'GeForce 6800 XT', '00c2': 'GeForce 6800 LE', '0394': 'GeForce 7600 LE', '0395': 'GeForce 7300 GT', '0390': 'GeForce 7650 GS', '0391': 'GeForce 7600 GT', '0392': 'GeForce 7600 GS', '0393': 'GeForce 7300 GT', '0398': 'GeForce Go 7600', '0169': 'GeForce 6250', '03d2': 'GeForce 6100 nForce 400', '03d1': 'GeForce 6100 nForce 405', '03d0': 'GeForce 6150SE nForce 430', '03d5': 'GeForce 6100 nForce 420', '0308': 'Quadro FX 2000', '0247': 'GeForce Go 6100', '0400': 'GeForce 8600 GTS', '01da': 'Quadro NVS 110M', '0402': 'GeForce 8600 GT', '0407': 'GeForce 8600M GT', '009d': 'Quadro FX 4500', '031a': 'GeForce FX Go5600', '031b': 'GeForce FX Go5650', '033f': 'Quadro FX 700', '01de': 'Quadro FX 350', '01db': 'Quadro NVS 120M', '032a': 'Quadro NVS 55/280 PCI', '0325': 'GeForce FX Go5250', '0324': 'GeForce FX Go5200', '0221': 'GeForce 6200', '0222': 'GeForce 6200 A-LE', '032b': 'Quadro FX 500/FX 600', '0327': 'GeForce FX 5100', '039e': 'Quadro FX 560', '053a': 'GeForce 7050 PV / NVIDIA nForce 630a', '0193': 'GeForce 8800 GTS', '0338': 'Quadro FX 3000', '0322': 'GeForce FX 5200', '0092': 'GeForce 7800 GTX', '040b': 'Quadro NVS 320M', '040c': 'Quadro FX 570M', '040d': 'Quadro FX 1600M', '0091': 'GeForce 7800 GTX', '0099': 'GeForce Go 7800 GTX', '0098': 'GeForce Go 7800', '0314': 'GeForce FX 5600XT', '0095': 'GeForce 7800 SLI', '0093': 'GeForce 7800 GS', '0311': 'GeForce FX 5600 Ultra', '0312': 'GeForce FX 5600', '0090': 'GeForce 7800 GTX'}
    return cards

    '''Cards supported up to driver 96xx'''
def nvmidcards():
    middlecards = {'0112': 'GeForce2 Go', '0113': 'Quadro2 MXR/EX/Go', '0110': 'GeForce2 MX/MX 400', '0111': 'GeForce2 MX 100/200', '0259': 'Quadro4 750 XGL', '0258': 'Quadro4 900 XGL', '0179': 'GeForce4 440 Go 64M', '0170': 'GeForce4 MX 460', '0171': 'GeForce4 MX 440', '0172': 'GeForce4 MX 420', '0173': 'GeForce4 MX 440-SE', '0174': 'GeForce4 440 Go', '0175': 'GeForce4 420 Go', '0176': 'GeForce4 420 Go 32M', '0177': 'GeForce4 460 Go', '0280': 'GeForce4 Ti 4800', '0185': 'GeForce4 MX 4000', '0181': 'GeForce4 MX 440 with AGP8X', '0183': 'GeForce4 MX 420 with AGP8X', '0182': 'GeForce4 MX 440SE with AGP8X', '0286': 'GeForce4 4200 Go', '0282': 'GeForce4 Ti 4800 SE', '0188': 'Quadro4 580 XGL', '0178': 'Quadro4 550 XGL', '0281': 'GeForce4 Ti 4200 with AGP8X', '0202': 'GeForce3 Ti 500', '0203': 'Quadro DCC', '0200': 'GeForce3', '0201': 'GeForce3 Ti 200', '01f0': 'GeForce4 MX Integrated GPU', '0251': 'GeForce4 Ti 4400', '0250': 'GeForce4 Ti 4600', '0253': 'GeForce4 Ti 4200', '017a': 'Quadro NVS', '017c': 'Quadro4 500 GoGL', '017d': 'GeForce4 410 Go 16M', '025b': 'Quadro4 700 XGL', '0288': 'Quadro4 980 XGL', '0289': 'Quadro4 780 XGL', '01a0': 'GeForce2 Integrated GPU', '018a': 'Quadro NVS 280 SD', '018c': 'Quadro NVS 50 PCI', '018b': 'Quadro4 380 XGL', '028c': 'Quadro4 700 GoGL'}
    return middlecards

    '''Cards supported up to driver 7xxx aka legacy'''
def nvoldcards():
    legacycards = {'0020': 'RIVA TNT', '0150': 'GeForce2 GTS/GeForce2 Pro', '0151': 'GeForce2 Ti', '0028': 'RIVA TNT2/TNT2 Pro', '0029': 'RIVA TNT2 Ultra', '0101': 'GeForce DDR', '0100': 'GeForce 256', '0103': 'Quadro', '002c': 'Vanta/Vanta LT', '0152': 'GeForce2 Ultra', '0153': 'Quadro2 Pro', '002d': 'RIVA TNT2 Model 64/Model 64 Pro', '00a0': 'Aladdin TNT2'}
    return legacycards


'''ATI CARDS'''
def atinewcards():
    cards = {'4e68': 'ATI Radeon 9800 PRO Secondary', '5568': 'ATI Radeon X800 Series Secondary', '712f': 'ATI FireGL V7350 Secondary', '5e4f': 'ATI Radeon X700/X500 Series', '712e': 'ATI FireGL V7300 Secondary', '712b': 'ATI Radeon X1800 Series Secondary', '712c': 'ATI Radeon X1800 Series Secondary', '712a': 'ATI Radeon X1800 Series Secondary', '5d6d': 'ATI Radeon X850 XT Platinum Edition Secondary', '5e4d': 'ATI Radeon X700', '5b70': 'ATI Radeon X300/X550 Series Secondary', '4a4b': 'ATI Radeon X800 XT', '7280': 'ATI Radeon X1950 Series', '4e49': 'ATI Radeon 9800', '4e48': 'ATI Radeon 9800 PRO', '4149': 'ATI Radeon 9500', '4148': 'ATI Radeon 9800 SE', '71c1': 'ATI Radeon X1650 Series', '4144': 'ATI Radeon 9500', '4147': 'ATI FireGL Z1', '4146': 'ATI Radeon 9600TX', '71c5': 'ATI Mobility Radeon X1600', '71da': 'ATI FireGL V5200', '4e47': 'ATI FireGL X1', '4e46': 'ATI Radeon 9600 TX', '7196': 'ATI Mobility Radeon X1350', '726d': 'ATI Radeon X1900 Series Secondary', '4a6c': 'ATI Radeon X800 Series Secondary', '5148': 'ATI FireGL 8800', '4175': 'ATI Radeon 9600 Series Secondary', '4b4c': 'ATI Radeon X850 XT Platinum Edition', '5461': 'ATI Mobility Radeon X300', '5460': 'ATI Mobility Radeon X300', '5464': 'ATI Mobility FireGL V3100', '7128': 'ATI Radeon X1800 Series Secondary', '71e6': 'ATI Radeon X1650 Series Secondary', '72a0': 'ATI Radeon X1950 Series Secondary', '5955': 'ATI Radeon Xpress Series', '7124': 'ATI FireGL V7200 Secondary', '4b4a': 'ATI Radeon X850 SE', '7120': 'ATI Radeon X1800 Series Secondary', '5954': 'ATI Radeon Xpress Series', '71c3': 'ATI Radeon X1300 Series', '4172': 'ATI Radeon 9600 Series Secondary', '724d': 'ATI Radeon X1900 Series', '71a0': 'ATI Radeon X1300 Series Secondary', '5965': 'ATI FireMV 2200 PCI', '5854': 'ATI Radeon Xpress Series', '71e1': 'ATI Radeon X1650 Series Secondary', '71d4': 'ATI Mobility FireGL V5250', '4e4b': 'ATI FireGL X2-256/X2-256t', '71ce': 'ATI Radeon X1300 Series', '71cd': 'ATI Radeon X1600 Series', '71d2': 'ATI FireGL V3400', '4b6a': 'ATI Radeon X850 SE Secondary', '4b6b': 'ATI Radeon X850 PRO Secondary', '4b6c': 'ATI Radeon X850 XT Platinum Edition Secondary', '5d4f': 'ATI Radeon X800 GTO', '726a': 'ATI Radeon X1900 Series Secondary', '4a4f': 'ATI Radeon X800 SE', '7247': 'ATI Radeon X1900 Series', '7246': 'ATI Radeon X1900 Series', '7245': 'ATI Radeon X1900 Series', '7244': 'ATI Radeon X1950 Series', '7243': 'ATI Radeon X1900 Series', '5569': 'ATI Radeon X800 GTO Secondary', '7240': 'ATI Radeon X1950 Series', '71fa': 'ATI FireGL V5200 Secondary', '7249': 'ATI Radeon X1900 Series', '7248': 'ATI Radeon X1900 Series', '556a': 'ATI Radeon X800 XT Platinum Edition Secondary', '714d': 'ATI Radeon X1300 Series', '714e': 'ATI Radeon X1300 Series', '4a4a': 'ATI Radeon X800 Series', '71e3': 'ATI Radeon X1300 Series Secondary', '714a': 'ATI Mobility Radeon X1300', '714b': 'ATI Mobility Radeon X1300', '714c': 'ATI Mobility Radeon X1300', '3e50': 'ATI Radeon X600/X550 Series', '3152': 'ATI Mobility Radeon X300', '3150': 'ATI Mobility Radeon X600', '726c': 'ATI Radeon X1900 Series Secondary', '3154': 'ATI Mobility FireGL V3200', '4b69': 'ATI Radeon X850 XT Secondary', '5e4a': 'ATI Radeon X700 XT', '4a6b': 'ATI Radeon X800 XT Secondary', '554a': 'ATI Radeon X800 XT Platinum Edition', '7149': 'ATI Mobility Radeon X1300', '7145': 'ATI Mobility Radeon X1400', '7146': 'ATI Radeon X1300 Series', '7147': 'ATI Radeon X1300 Series', '7140': 'ATI Radeon X1600 Series', '7160': 'ATI Radeon X1600 Series Secondary', '5571': 'ATI FireGL V5100 Secondary', '5570': 'ATI FireGL V7100 Secondary', '724f': 'ATI Radeon X1900 Series', '5673': 'ATI Mobility Radeon X700 Secondary', '724c': 'ATI Radeon X1900 Series', '724b': 'ATI Radeon X1900 Series', '5874': 'ATI Radeon Xpress Series', '71c0': 'ATI Radeon X1600 Series', '71f2': 'ATI FireGL V3400 Secondary', '556e': 'ATI Radeon X800 SE Secondary', '7129': 'ATI Radeon X1800 Series Secondary', '726b': 'ATI Radeon X1900 Series Secondary', '4e44': 'ATI Radeon 9700 PRO', '5975': 'ATI Radeon Xpress Series', '5974': 'ATI Radeon Xpress Series', '72b1': 'ATI Radeon X1650 Series Secondary', '71c2': 'ATI Radeon X1600 Series', '4e45': 'ATI Radeon 9500 PRO / 9700', '5677': 'ATI Radeon X700 Series Secondary', '4b4b': 'ATI Radeon X850 PRO', '5d50': 'ATI FireGL V7200', '71c4': 'ATI Mobility FireGL V5200', '5a61': 'ATI Radeon Xpress Series', '5a62': 'ATI Radeon Xpress Series', '5a63': 'ATI Radeon Xpress Series', '5e6b': 'ATI Radeon X700 PRO Secondary', '7109': 'ATI Radeon X1800 Series', '4a4c': 'ATI Radeon X800 Series', '7260': 'ATI Radeon X1950 Series Secondary', '71c6': 'ATI Radeon X1650 Series', '3e70': 'ATI Radeon X600/X550 Series Secondary', '4a6f': 'ATI Radeon X800 SE Secondary', '5548': 'ATI Radeon X800 Series', '4a6d': 'ATI FireGL X3-256 Secondary', '7269': 'ATI Radeon X1900 Series Secondary', '7268': 'ATI Radeon X1900 Series Secondary', '4a6a': 'ATI Radeon X800 Series Secondary', '5d6f': 'ATI Radeon X850 PRO Secondary', '7265': 'ATI Radeon X1900 Series Secondary', '7264': 'ATI Radeon X1950 Series Secondary', '7267': 'ATI Radeon X1900 Series Secondary', '7266': 'ATI Radeon X1900 Series Secondary', '5d77': 'ATI Radeon X800 XT Secondary', '7152': 'ATI FireGL V3300', '7263': 'ATI Radeon X1900 Series Secondary', '5e6c': 'ATI Radeon X700 SE Secondary', '4a74': 'ATI Radeon X800 VE Secondary', '71e2': 'ATI Radeon X1600 Series Secondary', '5d49': 'ATI Mobility FireGL V5100', '5d48': 'ATI Mobility Radeon X800 XT', '4a70': 'ATI Radeon X800 XT Platinum Edition Secondary', '4a69': 'ATI Radeon X800 PRO Secondary', '5e4b': 'ATI Radeon X700 PRO', '5d45': 'ATI FireMV 2200 PCI Secondary', '716e': 'ATI Radeon X1300 Series Secondary', '7291': 'ATI Radeon X1650 Series', '5d52': 'ATI Radeon X850 XT', '4a50': 'ATI Radeon X800 XT Platinum Edition', '4a68': 'ATI Radeon X800 Series Secondary', '5551': 'ATI FireGL V5100', '5550': 'ATI FireGL V7100', '4b49': 'ATI Radeon X850 XT', '5657': 'ATI Radeon X700 Series', '5652': 'ATI Mobility Radeon X700', '5653': 'ATI Mobility Radeon X700', '5e6d': 'ATI Radeon X700 Secondary', '4174': 'ATI FireGL T2 Secondary', '4e71': 'ATI Radeon 9600 Series Secondary', '4170': 'ATI Radeon 9600 Series Secondary', '4171': 'ATI Radeon 9600 Series Secondary', '5d70': 'ATI FireGL V7200 Secondary', '4173': 'ATI Radeon 9550 Secondary', '7162': 'ATI Radeon X1300 Series Secondary', '7163': 'ATI Radeon X1300 PRO Secondary', '5d4a': 'ATI Mobility Radeon X800', '7166': 'ATI Radeon X1300 Series Secondary', '7167': 'ATI Radeon X1300 Series Secondary', '5d4d': 'ATI Radeon X850 XT Platinum Edition', '5b74': 'ATI FireGL V3100 Secondary', '5b75': 'ATI FireMV 2200 Secondary', '3e54': 'ATI FireGL V3200', '5e68': 'ATI FireGL V5000 Secondary', '716d': 'ATI Radeon X1300 Series Secondary', '5b72': 'ATI Radeon X600 Series Secondary', '5b73': 'ATI Radeon X550 Secondary', '554b': 'ATI Radeon X800 GT', '715f': 'ATI Radeon X1300 Series', '715e': 'ATI Radeon X1300 Series', '726f': 'ATI Radeon X1900 Series Secondary', '554f': 'ATI Radeon X800', '71ee': 'ATI Radeon X1300 Series Secondary', '554d': 'ATI Radeon X800 XL', '554e': 'ATI Radeon X800 GT', '710a': 'ATI Radeon X1800 Series', '710b': 'ATI Radeon X1800 Series', '71ed': 'ATI Radeon X1600 Series Secondary', '710e': 'ATI FireGL V7300', '710f': 'ATI FireGL V7350', '5549': 'ATI Radeon X800 GTO', '7142': 'ATI Radeon X1300 Series', '7172': 'ATI FireGL V3300 Secondary', '7143': 'ATI Radeon X1300 PRO', '5a42': 'ATI Radeon Xpress Series', '5a43': 'ATI Radeon Xpress Series', '5a41': 'ATI Radeon Xpress Series', '4167': 'ATI FireGL Z1 Secondary', '4166': 'ATI Radeon 9600TX Secondary', '71a1': 'ATI Radeon X1600 Series Secondary', '4164': 'ATI Radeon 9500 Secondary', '4e67': 'ATI FireGL X1 Secondary', '4e66': 'ATI Radeon 9600 TX Secondary', '4e65': 'ATI Radeon 9500 PRO / 9700 Secondary', '4e64': 'ATI Radeon 9700 PRO Secondary', '4a4e': 'ATI Mobility Radeon 9800', '4a4d': 'ATI FireGL X3-256', '718b': 'ATI Mobility Radeon X1350', '718c': 'ATI Mobility Radeon X1350', '718d': 'ATI Mobility Radeon X1450', '4e6a': 'ATI Radeon 9800 XT Secondary', '4169': 'ATI Radeon 9500 Secondary', '4168': 'ATI Radeon 9800 SE Secondary', '5b65': 'ATI FireMV 2200', '5b64': 'ATI FireGL V3100', '5b63': 'ATI Radeon X550', '5b62': 'ATI Radeon X600 Series', '4a54': 'ATI Radeon X800 VE', '5b60': 'ATI Radeon X300/X550 Series', '556b': 'ATI Radeon X800 GT Secondary', '4a48': 'ATI Radeon X800 Series', '717e': 'ATI Radeon X1300 Series Secondary', '71a3': 'ATI Radeon X1300 Series Secondary', '717f': 'ATI Radeon X1300 Series Secondary', '724a': 'ATI Radeon X1900 Series', '564a': 'ATI Mobility FireGL V5000', '4e4a': 'ATI Radeon 9800 XT', '564b': 'ATI Mobility FireGL V5000', '556d': 'ATI Radeon X800 XL Secondary', '564f': 'ATI Mobility Radeon X700 XL', '7100': 'ATI Radeon X1800 Series', '7101': 'ATI Mobility Radeon X1800 XT', '7102': 'ATI Mobility Radeon X1800', '7103': 'ATI Mobility FireGL V7200', '7104': 'ATI FireGL V7200', '7106': 'ATI Mobility FireGL V7100', '7181': 'ATI Radeon X1600 Series', '7108': 'ATI Radeon X1800 Series', '71a7': 'ATI Radeon X1300 Series Secondary', '556f': 'ATI Radeon X800 GTO Secondary', '5d57': 'ATI Radeon X800 XT', '4152': 'ATI Radeon 9600 Series', '4153': 'ATI Radeon 9550', '4150': 'ATI Radeon 9600 Series', '4151': 'ATI Radeon 9600 Series', '4154': 'ATI FireGL T2', '4155': 'ATI Radeon 9600 Series', '4e56': 'ATI Mobility Radeon 9550', '4e54': 'ATI Mobility FireGL T2/T2e', '4e52': 'ATI Mobility Radeon 9500', '5e6f': 'ATI Radeon X700/X500 Series Secondary', '4e50': 'ATI Mobility Radeon 9600/9700 Series', '4e51': 'ATI Radeon 9600 Series', '4e6b': 'ATI FireGL X2-256/X2-256t Secondary', '5e48': 'ATI FireGL V5000', '5e49': 'ATI FireGL V3300', '4a49': 'ATI Radeon X800 PRO', '5e6a': 'ATI Radeon X700 XT Secondary', '5d72': 'ATI Radeon X850 XT Secondary', '5e4c': 'ATI Radeon X700 SE', '7180': 'ATI Radeon X1300 Series', '3e74': 'ATI FireGL V3200 Secondary', '71e0': 'ATI Radeon X1600 Series Secondary', '7183': 'ATI Radeon X1300 Series', '710c': 'ATI Radeon X1800 Series', '4e69': 'ATI Radeon 9800 Secondary', '7186': 'ATI Mobility Radeon X1450', '7187': 'ATI Radeon X1300 Series'}
    return cards

def atimidcards():#DOESN'T EXIST
    middlecards = {'noneid': 'none'}
    return middlecards

def atioldcards():
    legacycards = {'4c6e': 'ATI Mobility / Radeon 9000 Secondary', '4c6f': 'ATI Radeon 9000 PRO Secondary', '4242': 'ATI Radeon 8500 AIW', '514d': 'ATI Radeon 9100 Series', '7834': 'ATI Radeon 9000/9100 PRO IGP Series', '514c': 'ATI Radeon 8500 Series', '5942': 'ATI Radeon 9250/9200 Series Secondary', '5940': 'ATI Radeon 9250 Secondary', '5941': 'ATI Radeon 9250/9200 Series Secondary', '7835': 'ATI Mobility Radeon 9000 IGP', '5c63': 'ATI Mobility / Radeon 9200', '5c61': 'ATI Mobility / Radeon 9200', '5c41': 'ATI Mobility / Radeon 9200 Secondary', '5c43': 'ATI Mobility / Radeon 9200 Secondary', '4967': 'ATI Radeon 9000 Series', '4966': 'ATI Radeon 9000 Series', '5962': 'ATI Radeon 9250/9200 Series', '5960': 'ATI Radeon 9250', '5964': 'ATI Radeon 9250/9200 Series', '5d44': 'ATI Radeon 9250/9200 Series Secondary', '5961': 'ATI Radeon 9250/9200 Series', '791f': 'ATI Radeon Xpress 1200 Series', '791e': 'ATI Radeon Xpress 1200 Series', '4c67': 'ATI Radeon 9000 PRO', '4c66': 'ATI Mobility / Radeon 9000', '7941': 'ATI Radeon Xpress 1200 Series', '7942': 'ATI Radeon Xpress 1200 Series', '793f': 'ATI Radeon Xpress 1200 Series', '5834': 'ATI Radeon 9000/9100 IGP Series', '5835': 'ATI Mobility Radeon 9000/9100 IGP Series', '496f': 'ATI Radeon 9000 Series Secondary', '496e': 'ATI Radeon 9000 Series Secondary'}
    return legacycards

def atiunsupported():#USELESS
    unsupportedcards = {'5159': 'ATI Radeon 7000 Series', '5157': 'ATI Radeon 7500 Series', '3171': 'ATI FireMV 2400 Secondary', '4437': 'ATI Mobility Radeon 7000 IGP', '4c58': 'ATI Mobility FireGL 7800', '4c59': 'ATI Mobility Radeon', '71de': 'ATI Mobility Radeon X1700', '4c57': 'ATI Mobility Radeon 7500', '5969': 'ATI ES1000', '4336': 'ATI Radeon IGP 320M', '4337': 'ATI Radeon IGP 340M', '5144': 'ATI Radeon 7200 Series', '4c64': 'ATI Mobility FireGL 9000', '3151': 'ATI FireMV 2400', '7105': 'ATI FireGL V5300', '515a': 'ATI Radeon 7000 Series', '7125': 'ATI FireGL V5300 Secondary', '515e': 'ATI ES1000', '515f': 'ATI ES1000', '4136': 'ATI Radeon IGP 320', '4137': 'ATI Radeon IGP 340', '4237': 'ATI Radeon 7000 IGP', '71d6': 'ATI Mobility Radeon X1700'}
    return unsupportedcards
